#/usr/bin/env python
#
#
import sys
import math
import cmath
import random
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.cm as cm
import time
import julia1
import julia2        

def plot(julia):
    #print "Plot Julia..."
    fig, ax = plt.subplots()
    ax.imshow(julia, interpolation='nearest', cmap=cm.cool)
    return fig, ax

def plotlabels(fig, ax, im_width, im_height, xmin,xmax,xwidth, ymin, ymax, yheight):    
    # Set the tick labels to the coordinates of z0 in the complex plane
    xtick_labels = np.linspace(xmin, xmax, xwidth / 0.5)
    ax.set_xticks([(x-xmin) / xwidth * im_width for x in xtick_labels])
    ax.set_xticklabels(['{:.1f}'.format(xtick) for xtick in xtick_labels])
    ytick_labels = np.linspace(ymin, ymax, yheight / 0.5)
    ax.set_yticks([(y-ymin) / yheight * im_height for y in ytick_labels])
    ax.set_yticklabels(['{:.1f}'.format(ytick) for ytick in ytick_labels])

def total():
    #print("Julia set fractal generator\n")
    im_width = 1000
    im_height = 1000
    xmin,xmax = -0.5, 0.5
    xwidth = xmax-xmin
    ymin, ymax = -0.5, 0.5
    yheight = ymax - ymin
    nitmax = 1000
    zabsmax = 2.0
    #title="Julia set fractal generator"
    start = time.time()
    julia = julia2.julialoop(im_width, im_height, xwidth, yheight, xmin, ymin, nitmax)
    end = time.time()
    print "Python reference time:",end-start
    #print julia
    npjulia = np.array(julia)
    npjulia = npjulia.reshape(im_width,im_height)
    fig, ax = plot(npjulia)
    plotlabels(fig, ax, im_width, im_height, xmin,xmax,xwidth, ymin, ymax, yheight)    
    plt.savefig('test_boost2.png')
    
if __name__ == '__main__':
    total()


    
