cdef extern from "complex.h":
     double cabs(double complex)

cdef extern from "mycalc.h":
     double calcz(double complex z, double complex c, double zabsmax)

import numpy as np
cimport numpy as np


def julia_loop(int im_width, int im_height, double xwidth, double yheight, double xmin, double ymin, int nitmax,double complex c):
    #print "Calculate the 2D plane..."
    cdef double zabsmax = 10
    cdef np.ndarray[double,ndim=1] julia = np.empty((im_width * im_height),'double')
    cdef double xx = im_width * xwidth
    cdef double yy = im_height * yheight
    cdef int ix, iy
    cdef int nit
    for i in range(im_width * im_height):
        ix = i / im_width
        iy = i - ix * im_width
        z = complex((ix/xx + xmin),(iy/yy  + ymin))
        julia[i] = calcz(z,c,zabsmax)
    return julia.reshape(im_width,im_height)

