#include "complex.h"
#include "mycalc.h"

double calcz(double complex z, double complex c, double zabsmax)
{
  int nit = 0;
  const int nitmax = 1000.;
  int i;
  for (i=0; i < nitmax; ++i)
    {
      double zr = creal(z);
      double zi = cimag(z);
      if ((zr * zr + zi*zi) > zabsmax || nit >= nitmax)
	{
	  return ((double) nit)/nitmax;
	}
      z = z*z + c;
      nit += 1;
    }
  return nit / nitmax;
}
